function exercise1()
clear;
clf;

DRAW_SINGLESTEPS=1;
DRAW_TRAJECTORIES=1;
NUMBER_OF_TRIES=1;

%data will be written to this file
fileName='log_diffStartingPositions.txt';

r=robot;
%Add here as many starting positions as you like

r=addStartPosition(r, [110 110]);
r=addStartPosition(r, [20 180]);
r=addStartPosition(r, [180 180]);
r=addStartPosition(r, [200 0]);

searchNoise = 0.0;
memoryNoise = 0.0;

w=world;
%1 means remove after learning, 2 before
w=addLandmark(w, [4 8], 0);
w=addLandmark(w, [200 200], 0);
w=addLandmark(w, [50 200], 0);

r.targetPosition=[100 100];

plotWorld(w, r);

file = fopen(fileName,'w');
for p=1:size(r.startPosition,1)
  disp(sprintf('  position: %f %f', r.startPosition(p,1), r.startPosition(p,2)));
  for t=1:NUMBER_OF_TRIES
    r.position=r.startPosition(p,:);
    fprintf(file, '%f\t', norm(r.position-r.targetPosition));
    trajectory = r.position;
    
    alvSumTarget=calcAlvSum(r.targetPosition, w.landmarksBeforeLearning, memoryNoise);
    
    for i=1:200
      alvSumCurrent=calcAlvSum(r.position, w.landmarksAfterLearning, searchNoise);
      diffAlv=alvSumCurrent-alvSumTarget;
      newX=r.speed*diffAlv;
      r.position=r.position-newX;
      if DRAW_SINGLESTEPS == 1
        plotSingleSteps(r)
      end
      if DRAW_TRAJECTORIES == 1
        trajectory = [trajectory; r.position];
      end
    end
    if DRAW_TRAJECTORIES == 1
      plotTrajectory(trajectory)
    end
    fprintf(file, '%f\t', norm(r.position-r.targetPosition));    
  end
  fprintf(file, '\n');    
end
fclose(file);
end

function plotTrajectory(trajectory)
plot(trajectory(:,1), trajectory(:,2))
axis([0 200 0 200]);
hold on
drawnow
end

function plotSingleSteps(r)
plot(r.position(1) ,r.position(2),'o',...
  'MarkerEdgeColor','b',...
  'MarkerFaceColor','b','MarkerSize',2);
axis([0 200 0 200]);
hold on
drawnow
end

function plotWorld(w, r)
figure(1)

%draw all landmarks
axis([0 200 0 200]);
plot(w.landmarks(:,1) ,w.landmarks(:,2),'o',...
  'MarkerEdgeColor','k',...
  'MarkerFaceColor','g','MarkerSize',10);
hold on

%draw landmarks that were removed before learning
if size(w.removedBeforeLearning,1)>0
  plot(w.removedBeforeLearning(:,1) ,w.removedBeforeLearning(:,2),'o',...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor','y','MarkerSize',10);
  hold on
end

%draw landmarks that were removed after learning
if size(w.removedAfterLearning,1)>0
  plot(w.removedAfterLearning(:,1) ,w.removedAfterLearning(:,2),'o',...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor','r','MarkerSize',10);
  hold on
end

%draw target position
plot(r.targetPosition(1), r.targetPosition(2),'*',...
  'MarkerEdgeColor','k',...
  'MarkerFaceColor','b','MarkerSize',20);
grid on
hold on
drawnow
end

