function exercise3()
clear;
clf;

DRAW_SINGLESTEPS=0;
DRAW_TRAJECTORIES=1;
NUMBER_OF_TRIES=5;

%data will be written to this file
fileName='log_diffNoOfLandmarks.txt';

r=robot;
for i=1:3
  x=rand(1)*200;
  y=rand(1)*200;
  r=addStartPosition(r, [x y]);
end

searchNoise = 0.05;
memoryNoise = 0.05;

w=world;
%1 means remove after learning, 2 before
w=addLandmark(w, [4 8], 0);
w=addLandmark(w, [200 200], 0);
w=addLandmark(w, [50 200], 0);

r.targetPosition=[100 100];

plotWorld(w, r);

file = fopen(fileName,'a');
for p=1:size(r.startPosition,1)
  fprintf('  position: %f %f\n', r.startPosition(p,1), r.startPosition(p,2));
  for t=1:NUMBER_OF_TRIES
    %disp(sprintf('    try: %i', t));
    fprintf('    try: %i\n', t);
    r.position=r.startPosition(p,:);
    trajectory = r.position;
    
    alvSumTarget=calcAlvSum(r.targetPosition, w.landmarksBeforeLearning, memoryNoise);
        
    for i=1:200
      alvSumCurrent=calcAlvSum(r.position, w.landmarksAfterLearning, searchNoise);
      diffAlv=alvSumCurrent-alvSumTarget;
      newX=r.speed*diffAlv;
      r.position=r.position-newX;
      if DRAW_SINGLESTEPS == 1
        plotSingleSteps(r)
      end
      if DRAW_TRAJECTORIES == 1
        trajectory = [trajectory; r.position];
      end
    end
    if DRAW_TRAJECTORIES == 1
      plotTrajectory(trajectory)
    end
    fprintf(file, '%f\t', norm(r.position-r.targetPosition));
  end
end
fprintf(file, '\n');
fclose(file);
end

function plotTrajectory(trajectory)
plot(trajectory(:,1), trajectory(:,2))
axis([0 200 0 200]);
hold on
drawnow
end

function plotSingleSteps(r)
plot(r.position(1) ,r.position(2),'o',...
  'MarkerEdgeColor','b',...
  'MarkerFaceColor','b','MarkerSize',2);
axis([0 200 0 200]);
hold on
drawnow
end

function plotWorld(w, r)
figure(1)

%draw all landmarks
axis([0 200 0 200]);
plot(w.landmarks(:,1) ,w.landmarks(:,2),'o',...
  'MarkerEdgeColor','k',...
  'MarkerFaceColor','g','MarkerSize',10);
hold on

%draw landmarks that were removed before learning
if size(w.removedBeforeLearning,1)>0
  plot(w.removedBeforeLearning(:,1) ,w.removedBeforeLearning(:,2),'o',...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor','y','MarkerSize',10);
  hold on
end

%draw landmarks that were removed after learning
if size(w.removedAfterLearning,1)>0
  plot(w.removedAfterLearning(:,1) ,w.removedAfterLearning(:,2),'o',...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor','r','MarkerSize',10);
  hold on
end

%draw target position
plot(r.targetPosition(1), r.targetPosition(2),'*',...
  'MarkerEdgeColor','k',...
  'MarkerFaceColor','b','MarkerSize',20);
grid on
hold on
drawnow
end
