clear;
%clf;

fileName='log_diffSearchNoise.txt';
data=load(fileName);

figure(2)
x=data(:,1);

%transform data so that each try gets the corresponding y-value
xP=[];
yP=[];
for i=1:size(data,1)
  for j=2:size(data,2)
    xP=[xP; data(i,1)];
    yP=[yP; data(i,j)];
  end
end

%plot each singe experiment
plot(xP, yP,'o',...
      'MarkerEdgeColor','k',...
      'MarkerFaceColor','k','MarkerSize',4);
xlabel('noise level');
ylabel('final distance from target');
hold on;

%linear regression
p=polyfit(xP,yP,1);
yy0=polyval(p,x); 
plot(x, yy0);
hold off

%correlation test
[RHO, PVAL] = corr(xP, yP);
disp(sprintf('cof: %f p-Value=%f\n\n', RHO, PVAL));

%boxplot
figure(3)
categories=data(:,1);
data(:,1)=[];
data=data';
boxplot(data,'orientation','vertical','labels',categories,'notch','on')
xlabel('noise level');
ylabel('final distance from target');

%test for significant differences

%plot mean and std
figure(4)
data=data';

y = mean(data,2);
e = std(data,1,2);
errorbar(x,y,e)
xlabel('noise level');
ylabel('final distance from target');

