clear;
%clf;

fileName='log_diffNoOfLandmarks.txt';
data=load(fileName);

figure(2)
x=[];
size(data,1)
for i=1:size(data,1)
  x=[x; i]
end

%transform data so that each try gets the corresponding y-value
xP=[];
yP=[];
for i=1:size(data,1)
  for j=1:size(data,2)
    xP=[xP; x(i)];
    yP=[yP; data(i,j)];
  end
end

%plot each singe experiment
plot(xP, yP,'o',...
      'MarkerEdgeColor','k',...
      'MarkerFaceColor','k','MarkerSize',4);
xlabel('condition');
ylabel('final distance from target');
hold on;

%linear regression
p=polyfit(xP,yP,1);
yy0=polyval(p,x); 
plot(x, yy0);
hold off

%correlation test
[RHO, PVAL] = corr(xP, yP);
disp(sprintf('cof: %f p-Value=%f\n\n', RHO, PVAL));

%boxplot
figure(3)
categories=x;
data=data';
boxplot(data,'orientation','vertical','labels',categories,'notch','on')
xlabel('condition');
ylabel('final distance from target');

%test for significant differences
for i=1:(size(x)-1)
  [h,p] = ttest(data(:,i), data(:,i+1));
  disp(sprintf('%i vs %i , p-Value=%0.5f', x(i), x(i+1), p))
end


%plot mean and std
figure(4)
data=data';

y = mean(data,2);
e = std(data,1,2);
errorbar(x,y,e)
xlabel('condition');
ylabel('final distance from target');
